diff --git openjdk-orig/hotspot/lsb/lsb_config.h openjdk/hotspot/lsb/lsb_config.h
new file mode 100644
index 0000000..013f6c7
--- /dev/null
+++ openjdk/hotspot/lsb/lsb_config.h
@@ -0,0 +1,219 @@
+/* LSB interfaces availability configuration file
+
+Think of it as of autoconf's config.h.  (Actually, if you're going to
+undermine the intent of this file, you actually may write an autoconf script
+for its contents.)  The constants defined here are used to determine
+availiability in compile-time.
+
+Also the file contains functions to determine availability in runtime.  They
+are named like function_available() and libsomething_available().
+
+NOTE on automatic conditions.  The macro __LSB_PROVIDES_xxx actually means
+``xxx can be reached via normal #include and does not require a wrapper''.
+That actually means that xxx should either be provided by LSB or a non-LSB
+build should be running atm.  That's why conditions have an additional maxterm
+``!defined __LSB_VERSION__''.
+*/
+
+#ifndef _LSB_CONFIG_H
+#define _LSB_CONFIG_H
+
+/* Several interfaces are not included in LSB but should be included or
+reviewed in future.  In order not to let you forget about them, I'm making
+the autobuild fail on newer standards, so that the autobuild maintainer
+would be notified about that.
+If you are not SURE, to what version the interface will be included,
+use __LSB_NEXT_STANDARD macro */
+
+#define __LSB_NEXT_STANDARD 41
+
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include "lsb_helpers.h"
+
+// pthread_getattr_np (bug #2364)
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_pthread_getattr_np
+#define pthread_getattr_np_available() 1
+#else
+LSB_AVAIL_RUNTIME(pthread_getattr_np);
+#endif
+
+// dlvsym (bug #2673)
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_dlvsym
+#define dlvsym_available() 1
+#else
+LSB_AVAIL_RUNTIME(dlvsym);
+#endif
+
+// sysinfo (bug #2163)
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_sysinfo
+#define sysinfo_available() 1
+#else
+LSB_AVAIL_RUNTIME(sysinfo);
+#endif
+
+
+// mntent group -- interfaces for reading /etc/fstab
+
+// mntent_r
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_setmntent
+#define setmntent_available() 1
+#define __LSB_PROVIDES_getmntent_r
+#define getmntent_r_available() 1
+#define __LSB_PROVIDES_endmntent
+#define endmntent_available() 1
+#define __LSB_PROVIDES_sysinfo
+#define sysinfo_available() 1
+#else
+LSB_AVAIL_RUNTIME(setmntent);
+LSB_AVAIL_RUNTIME(getmntent_r);
+LSB_AVAIL_RUNTIME(endmntent);
+#endif
+
+
+// snd_rawmidi_info
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_snd_rawmidi_info
+#define snd_rawmidi_info_available() 1
+#else
+LSB_AVAIL_RUNTIME(snd_rawmidi_info);
+#endif
+
+
+// snd_rawmidi_info_get_card
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_snd_rawmidi_info_get_card
+#define snd_rawmidi_info_get_card_available() 1
+#else
+LSB_AVAIL_RUNTIME(snd_rawmidi_info_get_card);
+#endif
+
+// Different flags
+
+// enum snd_seq_event_type
+// I think it's a mistake that it's not in LSB.
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_snd_seq_event_type
+#define snd_seq_event_type_available() 1
+#else
+#define snd_seq_event_type_available() 0
+#endif
+
+// SO_PEERCRED
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_SO_PEERCRED
+#define SO_PEERCRED_available() 1
+#else
+#define SO_PEERCRED_available() 0
+#endif
+
+// IFHWADDRLEN
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_IFHWADDRLEN
+#define IFHWADDRLEN_available() 1
+#else
+#define IFHWADDRLEN_available() 0
+#endif
+
+
+// dlopen's RTLD_NOLOAD
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_RTLD_NOLOAD
+#define RTLD_NOLOAD_available() 1
+#else
+#define RTLD_NOLOAD_available() 0
+#endif
+
+
+//MAP_NORESERVE
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_MAP_NORESERVE
+#define MAP_NORESERVE_available() 1
+#else
+#define MAP_NORESERVE_available() 0
+#endif
+
+
+//FT_StreamRec.  Small omission.
+#if (__LSB_VERSION__ >= 41) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_FT_StreamRec
+#define FT_StreamRec_available() 1
+#else
+#define FT_StreamRec_available() 0
+#endif
+
+
+// FT_GlyphSlot_Embolden
+#if (__LSB_VERSION__ >= __LSB_NEXT_STANDARD) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_FT_GlyphSlot_Embolden
+#define FT_GlyphSlot_Embolden_available() 1
+#else
+LSB_AVAIL_RUNTIME(FT_GlyphSlot_Embolden);
+#endif
+
+// FT_GlyphSlot_Oblique
+#if (__LSB_VERSION__ >= __LSB_NEXT_STANDARD) || (!defined __LSB_VERSION__)
+#define __LSB_PROVIDES_FT_GlyphSlot_Oblique
+#define FT_GlyphSlot_Oblique_available() 1
+#else
+LSB_AVAIL_RUNTIME(FT_GlyphSlot_Oblique);
+#endif
+
+
+
+// The support of the following functions is not planned
+// Therefore, we have to enwrap them in ifdef condition that triggers only
+// if we're doing an lsb build.
+
+#ifdef __LSB_VERSION__
+
+
+// libthread_db
+#undef __LSB_PROVIDES_libthread_db
+LSB_AVAIL_RUNTIME(libthread_db);
+
+// ptrace (bug #1664)
+#undef __LSB_PROVIDES_ptrace
+LSB_AVAIL_RUNTIME(ptrace);
+
+// syscalls
+#undef __LSB_PROVIDES_syscall_gettid
+#define syscall_gettid_available() 0
+// For more fine grained syscall availability and calling interfaces see
+// include/syscall.h
+
+#undef __LSB_PROVIDES_syscall_fork
+#undef __LSB_PROVIDES_syscall_exevce
+
+#undef __LSB_PROVIDES_NAME_MAX
+
+// This flag is used in such a way, that it actually does no sense on modern 
+// kernels and workarounds RFC incompliance of older ones.  So, it does no
+// harm to leave this as never-in-lsb and define the flag.
+// For more info see http://marc.info/?l=linux-netdev&m=120851487828101&w=2
+#undef __LSB_PROVIDES_IPV6_CHECKSUM
+
+
+// mincore is too low-level and Java specs allow it to be absent
+#undef __LSB_PROVIDES_mincore
+
+
+// The value is used in the implementation of library inlined into openjdk
+#undef __LSB_PROVIDES_MSG_FIN
+
+
+#endif // __LSB_VERSION__
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif // include sentry
+
diff --git openjdk-orig/hotspot/lsb/lsb_flags.h openjdk/hotspot/lsb/lsb_flags.h
new file mode 100644
index 0000000..10db826
--- /dev/null
+++ openjdk/hotspot/lsb/lsb_flags.h
@@ -0,0 +1,94 @@
+/* LSB flags overrides
+
+Some interfaces are in LSB but do not have certain options, i.e. some flags
+are missing.  This doesn't cause errors in dynamic linking, but can cause
+1) Absence of flag in interface's implementation as LSB doesn't require it
+    That's unlikely to happen, because hardly anyone would re-compile 
+    glibc or something else like in gentoo with its use-flags.
+2) Not enough quality for interface - the flag is not tested.
+    OpenJDK's code is very vulnerable and workarounds are always added in
+    these cases.  But if a flag requires non-lsb workaround, then this flag
+    is better be added and tested.
+
+So, this file provides the flags and other compile-time stuff that is declared
+in headers, that are included to LSB, but is itself absent from LSB.
+
+*/
+
+#ifndef _LSB_FLAGS_H
+#define _LSB_FLAGS_H
+
+#ifndef __LSB_PROVIDES_MAP_NORESERVE
+// from <sys/mmap.h>
+#define MAP_NORESERVE 0x04000
+#endif
+
+// For register flags
+#include "static/lsb_ucontext.h"
+
+// To use NAME_MAX in some places
+#ifndef __LSB_PROVIDES_NAME_MAX
+// It's 256, but we'll give it more--just in case
+#define NAME_MAX_FORBIDDEN 1024
+#else
+#define NAME_MAX_FORBIDDEN NAME_MAX
+#endif
+
+
+// SO_PEERCRED.  Unix domain socket to allow inter-process (or inter-thread)
+// communication with authorization with uids and gids.
+#ifndef __LSB_PROVIDES_SO_PEERCRED
+// from 2.6.30 kernel sources
+#if (defined __powerpc__) || (defined __powerpc64__)
+#define SO_PEERCRED 21
+#else
+#define SO_PEERCRED	17
+#endif
+
+//now we also need structure to store cred_info.  That's simple.
+
+struct ucred
+{
+  pid_t pid;			/* PID of sending process.  */
+  uid_t uid;			/* UID of sending process.  */
+  gid_t gid;			/* GID of sending process.  */
+};
+
+#endif
+
+
+#include "static/lsb_dlfcn.h"
+
+
+#ifndef __LSB_PROVIDES_IFHWADDRLEN
+// defined in net/if.h
+#define IFHWADDRLEN 6
+#endif
+
+
+
+#ifndef __LSB_PROVIDES_IPV6_CHECKSUM
+#define IPV6_CHECKSUM 7
+#endif
+
+
+#ifndef __LSB_PROVIDES_MSG_FIN
+//taken from glibc sources.
+#define MSG_FIN 0x200
+#endif
+
+
+// for alsa missing interfaces
+#include "static/alsa/lsb_seq_event.h"
+
+
+#ifndef __LSB_PROVIDES_FT_StreamRec
+//that's just an omission in freetype
+#include "ft2build.h"
+#include FT_SYSTEM_H
+typedef struct  FT_StreamRec_ FT_StreamRec;
+#endif
+
+#endif //include sentry
+
+
diff --git openjdk-orig/hotspot/lsb/lsb_helpers.c openjdk/hotspot/lsb/lsb_helpers.c
new file mode 100644
index 0000000..62e4237
--- /dev/null
+++ openjdk/hotspot/lsb/lsb_helpers.c
@@ -0,0 +1,20 @@
+
+#ifndef __LSB_VERSION__
+// dlfcn.h manual requires _GNU_SOURCE for RTLD_DEFAULT
+#define _GNU_SOURCE
+#endif
+
+#include <dlfcn.h>
+#include "lsb_helpers.h"
+
+char DEFAULT_name[] = "RTLD_DEFAULT";
+int DEFAULT_available()
+{
+    //always available
+    return 1;
+}
+void* DEFAULT_handle()
+{
+    return RTLD_DEFAULT;
+}
+
diff --git openjdk-orig/hotspot/lsb/lsb_helpers.h openjdk/hotspot/lsb/lsb_helpers.h
new file mode 100644
index 0000000..03134a8
--- /dev/null
+++ openjdk/hotspot/lsb/lsb_helpers.h
@@ -0,0 +1,87 @@
+/* LSB wrapper helpers
+
+The header file contains helpers for LSB wrappers generation.
+*/
+
+#ifndef __LSB_HELPERS_H
+#define __LSB_HELPERS_H
+
+#include <dlfcn.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+/* Library dlopen helpers.  lib_id is an identifier to refer to this library
+   and lib_soname is a string with sonema to dlopen.
+*/
+#define LSB_LIB_LOAD(lib_id, lib_soname) \
+void * lib_id##_h; \
+int lib_id##_h_tried = 0; \
+char lib_id##_name[] = lib_soname; \
+int lib_id##_available() \
+{ \
+    if (!lib_id##_h_tried){ \
+        lib_id##_h = dlopen(lib_soname,RTLD_LAZY | RTLD_GLOBAL); \
+        lib_id##_h_tried = 1; \
+        return (int)(lib_id##_h); \
+    }else{ \
+        return (int)(lib_id##_h); \
+    } \
+} \
+void* lib_id##_handle() \
+{ \
+    if (! lib_id##_available()){ \
+        fprintf(stderr,"Required library %s is absent in your system.  LSB does not require it to present, but the program can't run without it.  Sorry.\n",lib_soname); \
+        exit(-1); \
+    } \
+    return lib_id##_h; \
+} \
+
+// availablilty declaration for lsb_config.h
+#define LSB_AVAIL_RUNTIME(something) extern int something##_available();
+
+// f - name of funciton defined in some other place
+// lib - id of library as supplied in LSB_LIB_LOAD
+#define LSB_CHECKER(lib,f) \
+__typeof__(f) * f##_a;  \
+char const* f##_lib_name = lib##_name;  \
+int f##_a_tried = 0;  \
+int f##_available() \
+{ \
+    if (f##_a_tried){ \
+        return (int)f##_a; \
+    }else{ \
+        if (!lib##_available()){ \
+            return 0; \
+        } \
+        *(void **) (&f##_a)=dlsym(lib##_handle(), #f); \
+        f##_a_tried = 1; \
+        return (int)f##_a; \
+    } \
+}
+
+/* Unfortunately, there is no way to predefine a macro for automatic wrapper 
+   generation.  So you're just to copy it from the header file and use the
+   LSB_WRAPPER_CALL macro, like that:
+
+        int function(int arg1, void* arg2)
+        {
+            LSB_WRAPPER_CALL(library_id,function,arg1,arg2);
+        }
+
+*/
+#define LSB_WRAPPER_CALL(f, ...) \
+    if (!f##_available()) \
+    { \
+        fprintf(stderr,"Required interface %s is absent in your system's library %s.  LSB does not require it to present, but the program can't run without it.  Sorry.\n",#f,f##_lib_name); \
+        exit(-1); \
+    } \
+    return (*f##_a)(__VA_ARGS__)
+
+/* Special handle for symbols that are dlsym'ed from RTLD_DEFAULT.
+   Such symbols should be assigned to DEFAULT library */
+extern char DEFAULT_name[];
+extern int DEFAULT_available();
+extern void* DEFAULT_handle();
+
+#endif //include sentry
+
diff --git openjdk-orig/hotspot/lsb/lsb_wrappers.c openjdk/hotspot/lsb/lsb_wrappers.c
new file mode 100644
index 0000000..d521a2c
--- /dev/null
+++ openjdk/hotspot/lsb/lsb_wrappers.c
@@ -0,0 +1,172 @@
+/* LSB wrapper implementation
+
+This unit conrains wrappers for non-lsb functions that are used throughout
+the OpenJDK project.  It dynamically loads them and implements functions
+to check their availibility in runtime as well as wrapper implementations
+with the same name as the original. */
+
+#include "lsb_config.h"
+#include "lsb_helpers.h"
+
+#ifndef __LSB_PROVIDES_libthread_db
+#include <thread_db.h>
+LSB_LIB_LOAD(thread_db,"libthread_db.so");
+LSB_CHECKER(thread_db,td_init);
+LSB_CHECKER(thread_db,td_ta_new);
+LSB_CHECKER(thread_db,td_thr_get_info);
+LSB_CHECKER(thread_db,td_ta_thr_iter);
+LSB_CHECKER(thread_db,td_ta_delete);
+
+/* As this function is used as checker for correct libthread_db loader
+   in OpenJDK code, let it return error gracefully if td_init wasn't actually
+   loaded.
+
+   We also rely on this function as on the first function from libthread_db
+   called in openjdk code.  So, we do some dlopen magic here for it to be
+   loaded correctly.
+*/
+td_err_e td_init (void)
+{
+    /* libthread_db contains several undefined symbols that should be found
+       in the library it's linked agains in compile time.  As we don't link
+       it in compile time due to its possible inavailability, we have to
+       use dlopen magic and re-open libsaproc.so to allow consequent dlsyms
+       to find undefined symbols dynamically.
+    */
+    dlopen("libsaproc.so",RTLD_NOW|RTLD_GLOBAL);
+    if (!td_init_available()){
+        fprintf(stderr,"Due to absence of libthread_db, the functionality is not supported on your system.\n");
+        return TD_ERR;
+    }
+    LSB_WRAPPER_CALL(td_init);
+}
+
+td_err_e td_ta_new (struct ps_prochandle *__ps, td_thragent_t **__ta)
+{
+    LSB_WRAPPER_CALL(td_ta_new,__ps,__ta);
+}
+
+td_err_e td_ta_delete (td_thragent_t *__ta)
+{
+    LSB_WRAPPER_CALL(td_ta_delete,__ta);
+}
+
+td_err_e td_ta_thr_iter (const td_thragent_t *__ta,
+				td_thr_iter_f *__callback, void *__cbdata_p,
+				td_thr_state_e __state, int __ti_pri,
+				sigset_t *__ti_sigmask_p,
+				unsigned int __ti_user_flags)
+{
+    LSB_WRAPPER_CALL(td_ta_thr_iter,__ta,__callback,__cbdata_p,__state,__ti_pri,__ti_sigmask_p,__ti_user_flags);
+}
+
+td_err_e td_thr_get_info (const td_thrhandle_t *__th, td_thrinfo_t *__infop)
+{
+    LSB_WRAPPER_CALL(td_thr_get_info,__th,__infop);
+}
+#endif  // __LSB_PROVIDES_libthread_db
+
+#ifndef __LSB_PROVIDES_ptrace
+#include <sys/ptrace.h>
+LSB_CHECKER(DEFAULT,ptrace);
+long int ptrace(enum __ptrace_request request, pid_t pid, void *addr, void *data)
+{
+    LSB_WRAPPER_CALL(ptrace,request,pid,addr,data);
+}
+#endif  // LSB_PROVIDES_ptrace
+
+#ifndef __LSB_PROVIDES_dlvsym
+#include <lsb_wrappers.h>
+// wrappers are assigned to DEFAULT library -- see lsb_wrappers.h
+LSB_CHECKER(DEFAULT,dlvsym);
+void *dlvsym(void *handle, char const *symbol, char const *version)
+{
+    LSB_WRAPPER_CALL(dlvsym,handle,symbol,version);
+}
+#endif  // __LSB_PROVIDES_dlvsym
+
+
+#ifndef __LSB_PROVIDES_pthread_getattr_np
+#include <lsb_wrappers.h>
+#include <pthread.h>
+// wrappers are assigned to DEFAULT library -- see lsb_wrappers.h
+LSB_CHECKER(DEFAULT,pthread_getattr_np);
+int pthread_getattr_np (pthread_t __th, pthread_attr_t *__attr)
+{
+    LSB_WRAPPER_CALL(pthread_getattr_np,__th,__attr);
+}
+#endif
+
+
+
+#ifndef __LSB_PROVIDES_sysinfo
+#include <lsb_wrappers.h>
+#include <sys/sysinfo.h>
+LSB_CHECKER(DEFAULT,sysinfo);
+int sysinfo (struct sysinfo *__info)
+{
+    LSB_WRAPPER_CALL(sysinfo,__info);
+}
+#endif
+
+
+#ifndef __LSB_PROVIDES_mincore
+#include <lsb_wrappers.h>
+LSB_CHECKER(DEFAULT,mincore);
+int mincore (void *__start, size_t __len, unsigned char *__vec)
+{
+    LSB_WRAPPER_CALL(mincore,__start,__len,__vec);
+}
+#endif
+
+
+#ifndef __LSB_PROVIDES_getmntent_r
+#include <mntent.h>
+LSB_CHECKER(DEFAULT,getmntent_r);
+struct mntent *getmntent_r (FILE *__restrict __stream,
+				   struct mntent *__restrict __result,
+				   char *__restrict __buffer,
+				   int __bufsize) 
+{
+    LSB_WRAPPER_CALL(getmntent_r,__stream,__result,__buffer,__bufsize);
+}
+#endif
+
+#ifndef __LSB_PROVIDES_setmntent
+#include <mntent.h>
+LSB_CHECKER(DEFAULT,setmntent);
+FILE *setmntent (__const char *__file, __const char *__mode) 
+{
+    LSB_WRAPPER_CALL(setmntent,__file,__mode);
+}
+#endif
+
+#ifndef __LSB_PROVIDES_endmntent
+#include <mntent.h>
+LSB_CHECKER(DEFAULT,endmntent);
+int endmntent (FILE *__stream) 
+{
+    LSB_WRAPPER_CALL(endmntent,__stream);
+}
+#endif
+
+
+#ifndef __LSB_PROVIDES_snd_rawmidi_info
+#include <lsb_wrappers.h>
+LSB_CHECKER(DEFAULT,snd_rawmidi_info);
+int snd_rawmidi_info(snd_rawmidi_t *rmidi, snd_rawmidi_info_t * info)
+{
+    LSB_WRAPPER_CALL(snd_rawmidi_info,rmidi,info);
+}
+#endif
+
+#ifndef __LSB_PROVIDES_snd_rawmidi_info_get_card
+#include <lsb_wrappers.h>
+LSB_CHECKER(DEFAULT,snd_rawmidi_info_get_card);
+int snd_rawmidi_info_get_card(const snd_rawmidi_info_t *obj)
+{
+    LSB_WRAPPER_CALL(snd_rawmidi_info_get_card,obj);
+}
+#endif
+
+
diff --git openjdk-orig/hotspot/lsb/lsb_wrappers.h openjdk/hotspot/lsb/lsb_wrappers.h
new file mode 100644
index 0000000..30dbb2b
--- /dev/null
+++ openjdk/hotspot/lsb/lsb_wrappers.h
@@ -0,0 +1,40 @@
+/* Wrappers for non-lsb interfaces
+
+Some interfaces are not in LSB, but are declared in the headeres that are
+in standard.  If we would like to call them, we need a separate file to
+include.
+
+Interfaces that require separate header are declared in header files
+stored in lsb/include/.
+
+The interfaces declared here are usually assigned to DEFAULT library in
+lsb_wrappers.c.  The reason is that if developer included an LSB header
+into its source file, he should have linked it with the proper library.
+So, at the point of dlopening the wrapped interface, its library should
+already be loaded.  All rules have exceptions, though.
+
+*/
+
+#ifndef _LSB_WRAPPERS_H
+#define _LSB_WRAPPERS_H 1
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#include "static/lsb_pthread.h"
+
+#include "static/lsb_dlfcn.h"
+
+#include "static/lsb_freetype.h"
+
+#include "static/sys/lsb_mman.h"
+
+#include "static/alsa/lsb_rawmidi.h"
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif //include sentry
+
diff --git openjdk-orig/hotspot/lsb/static/alsa/lsb_rawmidi.h openjdk/hotspot/lsb/static/alsa/lsb_rawmidi.h
new file mode 100644
index 0000000..d65a53a
--- /dev/null
+++ openjdk/hotspot/lsb/static/alsa/lsb_rawmidi.h
@@ -0,0 +1,19 @@
+
+#ifndef _ALSA_RAWMIDI_H_OPENJDK_WRAPPER
+#define _ALSA_RAWMIDI_H_OPENJDK_WRAPPER
+
+#include <alsa/rawmidi.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+int snd_rawmidi_info_get_card(const snd_rawmidi_info_t *obj);
+int snd_rawmidi_info(snd_rawmidi_t *rmidi, snd_rawmidi_info_t * info);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif // include sentry
+
diff --git openjdk-orig/hotspot/lsb/static/alsa/lsb_seq_event.h openjdk/hotspot/lsb/static/alsa/lsb_seq_event.h
new file mode 100644
index 0000000..d9bd643
--- /dev/null
+++ openjdk/hotspot/lsb/static/alsa/lsb_seq_event.h
@@ -0,0 +1,144 @@
+
+
+#ifndef _ALSA_SEQ_EVENT_H_OPENJDK_WRAPPER
+#define _ALSA_SEQ_EVENT_H_OPENJDK_WRAPPER
+
+#ifndef __LSB_PROVIDES_snd_seq_event_type
+
+/** Sequencer event type */
+enum snd_seq_event_type {
+	/** system status; event data type = #snd_seq_result_t */
+	SND_SEQ_EVENT_SYSTEM = 0,
+	/** returned result status; event data type = #snd_seq_result_t */
+	SND_SEQ_EVENT_RESULT,
+
+	/** note on and off with duration; event data type = #snd_seq_ev_note_t */
+	SND_SEQ_EVENT_NOTE = 5,
+	/** note on; event data type = #snd_seq_ev_note_t */
+	SND_SEQ_EVENT_NOTEON,
+	/** note off; event data type = #snd_seq_ev_note_t */
+	SND_SEQ_EVENT_NOTEOFF,
+	/** key pressure change (aftertouch); event data type = #snd_seq_ev_note_t */
+	SND_SEQ_EVENT_KEYPRESS,
+	
+	/** controller; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_CONTROLLER = 10,
+	/** program change; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_PGMCHANGE,
+	/** channel pressure; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_CHANPRESS,
+	/** pitchwheel; event data type = #snd_seq_ev_ctrl_t; data is from -8192 to 8191) */
+	SND_SEQ_EVENT_PITCHBEND,
+	/** 14 bit controller value; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_CONTROL14,
+	/** 14 bit NRPN;  event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_NONREGPARAM,
+	/** 14 bit RPN; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_REGPARAM,
+
+	/** SPP with LSB and MSB values; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_SONGPOS = 20,
+	/** Song Select with song ID number; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_SONGSEL,
+	/** midi time code quarter frame; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_QFRAME,
+	/** SMF Time Signature event; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_TIMESIGN,
+	/** SMF Key Signature event; event data type = #snd_seq_ev_ctrl_t */
+	SND_SEQ_EVENT_KEYSIGN,
+	        
+	/** MIDI Real Time Start message; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_START = 30,
+	/** MIDI Real Time Continue message; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_CONTINUE,
+	/** MIDI Real Time Stop message; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_STOP,
+	/** Set tick queue position; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_SETPOS_TICK,
+	/** Set real-time queue position; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_SETPOS_TIME,
+	/** (SMF) Tempo event; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_TEMPO,
+	/** MIDI Real Time Clock message; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_CLOCK,
+	/** MIDI Real Time Tick message; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_TICK,
+	/** Queue timer skew; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_QUEUE_SKEW,
+	/** Sync position changed; event data type = #snd_seq_ev_queue_control_t */
+	SND_SEQ_EVENT_SYNC_POS,
+
+	/** Tune request; event data type = none */
+	SND_SEQ_EVENT_TUNE_REQUEST = 40,
+	/** Reset to power-on state; event data type = none */
+	SND_SEQ_EVENT_RESET,
+	/** Active sensing event; event data type = none */
+	SND_SEQ_EVENT_SENSING,
+
+	/** Echo-back event; event data type = any type */
+	SND_SEQ_EVENT_ECHO = 50,
+	/** OSS emulation raw event; event data type = any type */
+	SND_SEQ_EVENT_OSS,
+
+	/** New client has connected; event data type = #snd_seq_addr_t */
+	SND_SEQ_EVENT_CLIENT_START = 60,
+	/** Client has left the system; event data type = #snd_seq_addr_t */
+	SND_SEQ_EVENT_CLIENT_EXIT,
+	/** Client status/info has changed; event data type = #snd_seq_addr_t */
+	SND_SEQ_EVENT_CLIENT_CHANGE,
+	/** New port was created; event data type = #snd_seq_addr_t */
+	SND_SEQ_EVENT_PORT_START,
+	/** Port was deleted from system; event data type = #snd_seq_addr_t */
+	SND_SEQ_EVENT_PORT_EXIT,
+	/** Port status/info has changed; event data type = #snd_seq_addr_t */
+	SND_SEQ_EVENT_PORT_CHANGE,
+
+	/** Ports connected; event data type = #snd_seq_connect_t */
+	SND_SEQ_EVENT_PORT_SUBSCRIBED,
+	/** Ports disconnected; event data type = #snd_seq_connect_t */
+	SND_SEQ_EVENT_PORT_UNSUBSCRIBED,
+
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR0 = 90,
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR1,
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR2,
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR3,
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR4,
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR5,
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR6,
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR7,
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR8,
+	/** user-defined event; event data type = any (fixed size) */
+	SND_SEQ_EVENT_USR9,
+
+	/** system exclusive data (variable length);  event data type = #snd_seq_ev_ext_t */
+	SND_SEQ_EVENT_SYSEX = 130,
+	/** error event;  event data type = #snd_seq_ev_ext_t */
+	SND_SEQ_EVENT_BOUNCE,
+	/** reserved for user apps;  event data type = #snd_seq_ev_ext_t */
+	SND_SEQ_EVENT_USR_VAR0 = 135,
+	/** reserved for user apps; event data type = #snd_seq_ev_ext_t */
+	SND_SEQ_EVENT_USR_VAR1,
+	/** reserved for user apps; event data type = #snd_seq_ev_ext_t */
+	SND_SEQ_EVENT_USR_VAR2,
+	/** reserved for user apps; event data type = #snd_seq_ev_ext_t */
+	SND_SEQ_EVENT_USR_VAR3,
+	/** reserved for user apps; event data type = #snd_seq_ev_ext_t */
+	SND_SEQ_EVENT_USR_VAR4,
+
+	/** NOP; ignored in any case */
+	SND_SEQ_EVENT_NONE = 255
+};
+#endif
+
+
+#endif // include sentry
+
